#
# AS namespace
#

# $Id: as_search.rb,v 1.3 2002/09/26 11:45:01 elca Exp $

require "socket"
require "timeout"

require "cache.rb"

$ra_host = "198.108.0.18" # whois.ra.net

$whois_cache = Hash.new

# from Michael Neumann (neumann@s-direktnet.de)'s whois.rb
def raw_whois (send_string, host)
  s = TCPsocket.open(host, 43)
  s.write(send_string+"\n")
  ret = ""
  while l = s.gets
    ret += l
  end
  s.close
  return ret
end

def as_get(str)
  begin
    tmp = nil
    timeout(30) {
      tmp = raw_whois(str, $ra_host)
    }
    tmp.split("\n").each {
      |i|
      if /^origin:/ =~ i
	return i.split[1]
      end
    }
    return nil
  rescue
    return nil
  end
end

def as_search(str)
  if $whois_cache[str] != nil
    $ml.log("cached AS: " + str + "=>" + $whois_cache[str]["as"])
    return $whois_cache[str]["as"]
  end

  tmp = as_get(str)
  if tmp != nil
    $ml.log("add as cache: " + str + "=>" + tmp)
    $whois_cache[str] = {
      "timeout" => Time.now.to_i + 3600, # 1$B;~4V(B
      "as"      => tmp
    }
  else
    $ml.log("add NULL AS cache: " + str + "=>default")
    $whois_cache[str] = {
      "timeout" => Time.now.to_i + 60,   # 1$BJ,(B
      "as"      => "default"
    }
  end

  return tmp
end

# $BDj4|E*$K8E$$FbMF$r:o=|(B
Thread.start do
  loop do
    sleep 5

    # $B%-%c%C%7%e$K;~4V@)8B$r$+$1$k(B
    cache_timeout($whois_cache, "as timeout: ")

    # $B%-%c%C%7%e$K%5%$%:@)8B$r$+$1$k(B
    cache_reduction($whois_cache, 1000, "as overflow: ")

  end
end

# end
